; Lab 2, Task 4 Sample Solution
.model small
.stack 100h

.code
						;assumption: usually ax=bx=cx=dx=0000h when DEBUG started
						;flags started at NV UP EI PL NZ NA PO NC
						;check initial content of [200h] and [201h], in this example [200h] = 50h, [201h]=0e8h
		add al,75h		;al = (al) + 75h = 0 + 75h = 75h; FLAGS=NV UP EI PL NZ NA PO NC
		add bl,89h		;bl = (bl) + 89h = 0 + 89h = 89h; FLAGS=NV UP EI NG NZ NA PO NC (note the result is negative NG - for 8-bit operation)
		add al,bl		;al = (al) + (bl) = 75h + 89h = 0feh; FLAGS=NV UP EI NG NZ NA PO NC
		inc cl			;cl = (cl) + 1 = 1h; FLAGS=NV UP EI PL NZ NA PO NC (note the result is positive PL)
		add al,cl		;al = (al) + (cl) = 0feh + 1 = 0ffh; FLAGS=NV UP EI NG NZ NA PE NC (note the result is negative NG and even parity PE)
		add bl,77h		;bl = (bl) + 77h = 89h + 77h = 100h (only 8-bit taken, and carry 1), i.e. bl = 00h with carry; FLAGS=NV UP EI PL ZR AC PE CY (note ZR, AC and CY)
		adc al,bl		;al = (al) + (bl) + carry = 0ffh + 00h + 1 = 100h, i.e. al = 00h with carry; FLAGS=NV UP EI PL ZR AC PE CY (note ZR, AC and CY)
		sub [200h],cl	;[200h] = [200h] - (cl) = 50h - 1 = 4fh; FLAGS=NV UP EI PL NZ AC PO NC (note NZ and NC); MASM insist on using label
		neg cx			;negate (cx) = 0 - (cx) = 0 - 1 = 0ffffh (-1); FLAGS=NV UP EI NG NZ AC PE CY (note NZ as expected)
		adc ax,[200h]	;ax = (ax) + [201h][200h] + carry = 0 + 0e84fh + 1 = 0e850h; note for 16-bit operation, 2 memory locations used and in little-endian order; FLAGS=NV UP EI NG NZ AC PE NC
		sub ax,5h		;ax = (ax) - 5h = 0e84bh; FLAGS=NV UP EI NG NZ AC PE NC
		add dh,4h		;dh = (dh) + 4h = 0 + 4h = 4h; FLAGS=NV UP EI PL NZ NA PO NC
		mul dh			;ax = (al) x (dh) = 4bh x 4h (taken as unsigned) = 12ch; note 8-bit multiplication gives 16-bit result in ax; FLAGS=OV UP EI PL NZ NA PO CY (note overflow OV but NA)
		add bx,20h		;bx = (bx) + 20h = 0 + 20h = 0020h; FLAGS=NV UP EI PL NZ NA PO NC
		div dh			;ax = (ax) / (dh) = 12ch / 4h = 4bh; note ax used as numerator; FLAGS=NV UP EI PL NZ NA PO NC
		imul dx			;dx : ax = (ax) * (dx) = 04bh * 0400h (taken as signed) = 12c00h, i.e. dx = 0001h, ax = 2c00h; note 16-bit multiplication gives 32-bit result in dx:ax; FLAGS=OV UP EI PL NZ NA PE CY
		div [200h]		;invalid: both DEBUG and MASM do not accept direct addressing for DIV instruction (no register involved)
		dec dx			;dx = (dx) - 1 = 1 - 1 = 0; FLAGS=NV UP EI PL ZR NA PE CY
		dec [200h]		;invalid: both DEBUG and MASM do not accept direct addressing for DEC instruction (no register involved)
		cmp ax,bx		;test (ax) - (bx) = 2c00h - 0020h = 2be0h; no change to registers, only affects FLAGS=NV UP EI PL NZ NA PO NC

end