; Lab 2, Task 5 Sample Solution
.model small
.stack 100h

.code
						;assumption: usually ax=bx=cx=dx=0000h when DEBUG started
						;flags started at NV UP EI PL NZ NA PO NC
		mov ax,0aaaah	;ax = 0aaaah; no change to FLAGS (data transfer instructions have no effect on FLAGS)
		mov cl,03h		;cl = 3h; no change to FLAGS
		shl ax,1h		;shift ax left by 1 position, initial ax = 1010,1010,1010,1010, after ax = (carry = 1) 0101,0101,0101,0100 (insert 0 at end) = 5554h; FLAGS=OV UP EI PL NZ NA PO CY (note CY)
		shl ax,cl		;shift ax left by cl=3 positions, initial ax = 0101,0101,0101,0100, after ax = (carry = 0) 1010,1010,1010,0000 (insert three 0 at end) = 0aaa0h; FLAGS=OV UP EI NG NZ NA PE NC
		
		mov ax,0aaaah	;ax = 0aaaah; no change to FLAGS (data transfer instructions have no effect on FLAGS)
		sal ax,1h		;with MASM, sal = shl; DEBUG does not recognise sal - replace with shl for testing; same as 3rd instruction above, ax = 5554h
		sal ax,cl		;with MASM, sal = shl; DEBUG does not recognise sal - replace with shl for testing; same as 4rd instruction above, ax = 0aaa0h

		mov dx,0aaaah	;dx = 0aaaah; no change to FLAGS
		shr dx,2h		;invalid: both DEBUG and MASM do not accept immediate data for shift count (right); they require the use of register cl
		shr dx,cl		;shift dx right by cl=3 positions, initial dx = 1010,1010,1010,1010, after dx = (insert three 0 at begin) 0001,0101,0101,0101 (carry=0) = 1555h; FLAGS=NV UP EI PL NZ NA PE NC

		mov dx,0aaaah	;dx = 0aaaah; no change to FLAGS
		sar dx,2h		;invalid: both DEBUG and MASM do not accept immediate data for shift count (right); they require the use of register cl
		sar dx,cl		;shift dx right by cl=3 positions, but this time (vs shr), repeat the MSB at the begin, initial dx = 1010,1010,1010,1010 (MSB=1, therefore insert three 1 at begin)
						;	after dx = (insert three 1 at begin) = 1111,0101,0101,0101 (carry=0) = 0f555h; FLAGS=NV UP EI NG NZ NA PE NC

		mov bl,08h		;bl = 08h; no change to FLAGS
		stc				;set carry flag; FLAGS=NV UP EI NG NZ NA PE CY (note carry set CY)
		rol bl,cl		;rotate bl left by cl=3 positions, the last bit rotated is copied into carry flag, initial bl = 0000,1000, after bl = (carry = 0) 0100,0 000 = 40h; FLAGS=NV UP EI NG NZ NA PE NC

		mov bl,08h		;bl = 08h; no change to FLAGS
		stc				;set carry flag; FLAGS=NV UP EI NG NZ NA PE CY (note carry set CY)
		rcl bl,cl		;rotate bl left by cl=3 positions, the rotation pass through the carry flag (i.e. carry flag value also rotated),
						;initial bl = 0000,1000, and carry = 1, number to rotate is bl = (1) 0000,1000, after bl = (carry = 0) 0100,0 100 = 44h; FLAGS=NV UP EI NG NZ NA PE NC
		stc				;set carry flag; FLAGS=NV UP EI NG NZ NA PE CY (note carry set CY)
		ror bl,cl		;rotate bl right by cl=3 positions, the last bit rotated is copied into carry flag, initial bl = 0100,0100, after bl = 1000,1000 (carry = 1) = 88h; FLAGS=OV UP EI NG NZ NA PE CY

end