; Lab 2, Task 3 Sample Solution
.model small
.stack 100h

.code
						;assumption: usually ax=bx=cx=dx=0000h when DEBUG started
						;flags started at NV UP EI PL NZ NA PO NC
		not dx			;inverse all bits of dx; dx=0ffffh; FLAGS=NV UP EI PL NZ NA PO NC
		not [200h]		;invalid: both DEBUG and MASM do not accept direct addressing for NOT instruction (no register involved)
		and dl,0c3h		;dl = (dl) AND 0c3h = 0ffh AND 0c3h (bit wise) = 0c3h; FLAGS=NV UP EI NG NZ NA PE NC (note the result is negative NG and even parity PE)
		and dl,0f0h		;dl = (dl) AND 0f0h = 0c3h AND 0f0h (bit wise) = 0c0h; FLAGS=NV UP EI NG NZ NA PE NC
		or bl,0b3h		;bl = (bl) OR 0b3h = 0 OR 0b3h (bit wise) = 0b3h; FLAGS=NV UP EI NG NZ NA PO NC (note result now has odd parity PO)
		mov [200h],dl	;[200h] = (dl) = 0c0h; this instruction does not affect the FLAGS; MASM insists on using label for direct memory address
		or bl,[200h]	;bl = (bl) OR [200h] = 0b3h OR 0c0h (bit wise) = 0f3h; FLAGS=NV UP EI NG NZ NA PE NC; MASM insists on using label
		mov [201h],bx	;[201h] = (bl) = 0f3h, [202h] = (bh) = 0; no effect on FLAGS; MASM insists on using label and word ptr
		or bx,dx		;bx = (bx) OR (dx) = 00f3h OR 0ffc0h (bit wise) = 0fff3h; FLAGS=NV UP EI NG NZ NA PE NC
		or ax,5511h		;ax = (ax) OR 5511h = 0 OR 5511h (bit wise) = 5511h; FLAGS=NV UP EI PL NZ NA PE NC (note the result is positive PL)
		and [200h],ah	;[200h] = [200h] AND (ah) = 0c0h AND 55h = 40h; FLAGS=NV UP EI PL NZ NA PO NC; MASM insists on using label
		and [201h],0feh	;invalid - 8086 instruction set does not allow immediate mode with memory address; MASM insists on using label
		or [201h],55h	;invalid - 8086 instruction set does not allow immediate mode with memory address; MASM insists on using label
		xor ax,ax		;ax = (ax) OR (ax) = 0; an effective way to clear register content; FLAGS=NV UP EI PL ZR NA PE NC (note the result is zero ZR)
		xchg dh,dl		;dh = 0c0h, dl = 0ffh; FLAGS=NV UP EI PL ZR NA PE NC (note the instruction does not change zero flag - different instructions have effect on different set of flags)
		xor bx,dx		;bx = (bx) XOR (dx) = 0fff3h XOR 0c0ffh = 3f0ch; FLAGS=NV UP EI PL NZ NA PE NC
		test bx,80a1h	;test only (bx) AND 80a1h = test 3f0ch AND 80a1h = 0; FLAGS=NV UP EI PL ZR NA PE NC

end